package com.qmth.distributed.print.business.mapper;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.qmth.distributed.print.business.entity.BasicSemester;
import com.qmth.teachcloud.common.bean.result.BasicSemesterResult;
import com.qmth.teachcloud.common.bean.result.BasicStudentResult;
import org.apache.ibatis.annotations.Param;

import java.util.Set;

/**
 * <p>
 * 学期字典表 Mapper 接口
 * </p>
 *
 * @author wangliang
 * @since 2021-10-28
 */
public interface BasicSemesterMapper extends BaseMapper<BasicSemester> {
    /**
     * 基础学期分页查询
     * @param iPage 分页参数
     * @param schoolId 学校id
     * @param orgIds 权限id
     * @return 分页结果
     */
    IPage<BasicSemesterResult> findBasicSemesterPage(@Param("iPage") Page<BasicSemesterResult> iPage,
                                                    @Param("schoolId") Long schoolId,
                                                    @Param("orgIds") Set<Long> orgIds);
}
